'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactI18next = require('react-i18next');

var _constants = require('../constants');

var _constants2 = _interopRequireDefault(_constants);

var _translate = require('../translate');

var _Action = require('../Actions/Action');

var _Action2 = _interopRequireDefault(_Action);

var _Badge = require('./Badge.scss');

var _Badge2 = _interopRequireDefault(_Badge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function renderDeleteIcon(onClick, disabled, t) {
	if (onClick) {
		return _react2.default.createElement(_Action2.default, {
			label: t('BADGE_DELETE', { defaultValue: 'delete' }),
			hideLabel: true,
			onClick: onClick,
			disabled: disabled,
			icon: 'talend-cross',
			className: (0, _classnames2.default)('tc-badge-delete-icon', _Badge2.default['tc-badge-delete-icon'])
		});
	}
	return null;
}

function Badge(_ref) {
	var label = _ref.label,
	    category = _ref.category,
	    onDelete = _ref.onDelete,
	    onSelect = _ref.onSelect,
	    selected = _ref.selected,
	    disabled = _ref.disabled,
	    t = _ref.t,
	    style = _ref.style;

	var containerClasses = (0, _classnames2.default)('tc-badge', _Badge2.default['tc-badge'], selected && ['tc-badge-selected', _Badge2.default['tc-badge-selected']], disabled && ['tc-badge-disabled', _Badge2.default['tc-badge-disabled']], !onDelete && ['tc-badge-readonly', _Badge2.default['tc-badge-readonly']]);
	var badgeClasses = (0, _classnames2.default)('tc-badge-button', _Badge2.default['tc-badge-button']);
	var labelClasses = (0, _classnames2.default)('tc-badge-label', _Badge2.default['tc-badge-label']);
	var categoryClasses = (0, _classnames2.default)('tc-badge-category', _Badge2.default['tc-badge-category']);

	return _react2.default.createElement(
		'div',
		{ className: containerClasses, style: style },
		_react2.default.createElement(
			'button',
			{ className: badgeClasses, onClick: onSelect, disabled: disabled },
			category && _react2.default.createElement(
				'span',
				{ className: categoryClasses },
				category
			),
			_react2.default.createElement(
				'span',
				{ className: labelClasses },
				label
			)
		),
		renderDeleteIcon(onDelete, disabled, t)
	);
}

Badge.propTypes = {
	label: _propTypes2.default.string,
	category: _propTypes2.default.string,
	onDelete: _propTypes2.default.func,
	onSelect: _propTypes2.default.func,
	selected: _propTypes2.default.bool,
	disabled: _propTypes2.default.bool,
	t: _propTypes2.default.func.isRequired,
	style: _propTypes2.default.object // eslint-disable-line react/forbid-prop-types
};

Badge.defaultProps = {
	selected: false,
	disabled: false
};

exports.default = (0, _reactI18next.translate)(_constants2.default, { i18n: _translate.DEFAULT_I18N })(Badge);